Description

Hi,

When adding a smart proxy runing on win2008 Server the smart proxy is not honoring dhcp exclude ranges. This results in

foreman/smart-proxy (dhcp) running on m$ reserving ip addresses which should not be reserved. A workaround for now is to

explicitly specify the start-stop address in the subnet tab.

I would expect if the start stop range is "optional" in the Provisioning-> subnets -> subnet TAB and not set by the user, that the smart

proxy queries the address scope and also looks for excluded addresses. Otherwise what happens is that addresses get reserved

even if they are exluded.

Here an example:

Excluded range in windows dhcp is 10.175.15.1 - 10.175.15.15. The fields start range stop range in the subnet tab are empty.

Add a new host, pick the subnet and let the smart-proxy negotiate an ip.

The smart proxy now tries to pick 10.175.15.1, .2, .3 as this ip is not reserved, just excluded.

-----------------------

What I would expect is if start stop address is not set: do

for each scope:

netsh dhcp server $SERVER scope $SCOPE show exluderange

Then if found an exluded range, calculate the start stop range.

Then get an ip.

Related issues:

Related to Smart Proxy - Bug #7766: ms_native dhcp smart proxy code scales po... Closed 10/01/2014

Related to Smart Proxy - Feature #34105: Windows MS DHCP Scope and Exclusions... New

Is duplicate of Smart Proxy - Bug #1280: MS DHCP ignores address exclusions Resolved

History

#1 - 01/24/2014 08:35 AM - Dominic Cleal

- Priority changed from Urgent to Normal

- translation missing: en.field_release deleted (3)

#2 - 01/28/2014 04:57 PM - Laurent Domb

This is also reproducable with a linux dhcp server. Just set 2 ranges on the dhcp server with 2 excluded ips. Looking at the code in subnet.rb the

function validate_ranges has no implementation for exclude ranges.

#3 - 01/29/2014 08:26 AM - Dominic Cleal
- Project changed from Foreman to Smart Proxy

- Category changed from Smart Proxy to DHCP

- Difficulty deleted (medium)

#4 - 01/29/2014 02:08 PM - Greg Sutcliffe

- Tracker changed from Bug to Feature

This is because Foreman uses the range set in the Subnet page of the Web UI to determine an available IP, not the ranges in the dhcpd.conf. If

they're empty, it will indeed use the whole range. As such, this isn't so much a bug as a feature request to use the ranges in dhcp server itself.

It's also worth noting that the current functionality could be relied upon by users (e.g. to allow Foreman to assign IPs outside the range) so we should

be careful about how we implement changes to this.

#5 - 08/06/2014 04:40 AM - Dominic Cleal

- Is duplicate of Bug #1280: MS DHCP ignores address exclusions added

#6 - 08/06/2014 04:40 AM - Dominic Cleal

- Status changed from New to Duplicate

#1280 also tracks this issue.

#7 - 08/17/2016 06:06 AM - Lukas Zapletal

- Subject changed from Smart proxy msdhcp does not honor exclude ranges  to Smart proxy DHCP plugin does not honor exclude ranges 

- Bugzilla link set to 1367549

I confirm this happens with ISC DHCP as well, it's DHCP core plugin feature.

#8 - 08/17/2016 06:25 AM - Lukas Zapletal

- Bugzilla link deleted (1367549)

#9 - 08/17/2016 06:56 AM - Anonymous

- Related to Bug #7766: ms_native dhcp smart proxy code scales poorly added

#10 - 08/17/2016 06:57 AM - Anonymous

https://github.com/theforeman/smart-proxy/pull/445 Fixes this issue on Windows server as ms api is used for ip allocation.

#11 - 08/17/2016 07:06 AM - Anonymous

We have quite a few issues related to our isc configuration/leases parser and this is one of them. If it turns out that we cannot easily create ipv6

reservations on isc dhcpd (as it seems to be the case atm) there may not be a point in fixing (rewriting most likely) the parser, as isc has a new dhcp

server that we probably should add support for instead (https://www.isc.org/kea/).

#12 - 12/08/2021 10:24 AM - Oliver Weinmann

- Related to Feature #34105: Windows MS DHCP Scope and Exclusions not honored added
